﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls;

namespace TreeListViewExample_WPF_NoXAML
{
	public class DropIndicationDetails : INotifyPropertyChanged
	{
		private object currentDraggedItem;
		private DropPosition currentDropPosition;
		private object currentDraggedOverItem;

		private ObservableCollection<object> draggedItems;

		public ObservableCollection<object> DraggedItems
		{
			get
			{
				return draggedItems;
			}
			set
			{
				if (this.DraggedItems != value)
				{
					draggedItems = value;
					OnPropertyChanged("DraggedItems");
				}
			}
		}
		
		public object CurrentDraggedOverItem
		{
			get
			{
				return currentDraggedOverItem;
			}
			set
			{
				if (this.currentDraggedOverItem != value)
				{
					currentDraggedOverItem = value;
					OnPropertyChanged("CurrentDraggedOverItem");
				}
			}
		}

		public int DropIndex { get; set; }

		public DropPosition CurrentDropPosition
		{
			get
			{
				return this.currentDropPosition;
			}
			set
			{
				if (this.currentDropPosition != value)
				{
					this.currentDropPosition = value;
					OnPropertyChanged("CurrentDropPosition");
				}
			}
		}

		public object CurrentDraggedItem
		{
			get
			{
				return this.currentDraggedItem;
			}
			set
			{
				if (this.currentDraggedItem != value)
				{
					this.currentDraggedItem = value;
					OnPropertyChanged("CurrentDraggedItem");
				}
			}
		}

		private int currentDraggedItemsCount;

		public int CurrentDraggedItemsCount
		{
			get
			{
				return this.currentDraggedItemsCount;
			}
			set
			{
				if (this.currentDraggedItemsCount != value)
				{
					this.currentDraggedItemsCount = value;
					this.OnPropertyChanged("CurrentDraggedItemsCount");
				}
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;

		protected virtual void OnPropertyChanged(PropertyChangedEventArgs e)
		{
			PropertyChangedEventHandler handler = PropertyChanged;
			if (handler != null)
			{
				handler(this, e);
			}
		}

		protected void OnPropertyChanged(string name)
		{
			PropertyChangedEventHandler handler = PropertyChanged;
			if (handler != null)
			{
				handler(this, new PropertyChangedEventArgs(name));
			}
		}
	}
}