﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using Telerik.Windows.Data;

namespace TreeListViewExample_WPF_NoXAML
{
	public class WarehouseItem : INotifyPropertyChanged
	{
		public WarehouseItem ParentItem { get; set; }
		public WarehouseItem(string name, int count, DateTime date, bool isExpanded, bool isExpandable)
		{
			this.Name = name;
			this.Count = count;
			this.Items = new RadObservableCollection<WarehouseItem>();
			this.Date = date;
			this.isExpanded = isExpanded;
			this.isExpandable = isExpandable;
		}

		private string name;
		public string Name
		{
			get
			{
				return this.name;
			}
			set
			{
				this.name = value;
				this.OnPropertyChanged("Name");
			}
		}
				
		private int count;
		public int Count
		{
			get
			{
				return this.count;
			}
			set
			{
				if (this.count != value)
				{
					this.count = value;
					this.OnPropertyChanged("Count");
				}
			}
		}
		
		private DateTime date;
		public DateTime Date
		{
			get
			{
				return this.date;
			}
			set
			{
				if (this.date != value)
				{
					this.date = value;
					this.OnPropertyChanged("Date");
				}
			}
		}
        
		public bool isExpanded;
		public bool IsExpanded
		{
			get
			{
				return this.isExpanded;
			}
			set
			{
				if (this.isExpanded != value)
				{
					this.isExpanded = value;
					OnPropertyChanged("IsExpanded");
				}
			}
		}

		public bool isExpandable;
		public bool IsExpandable
		{
			get
			{
				return this.isExpandable;
			}
			set
			{
				if (this.isExpandable != value)
				{
					this.isExpandable = value;
					OnPropertyChanged("IsExpandable");
				}
			}
		}

		public RadObservableCollection<WarehouseItem> Items
		{
			get;
			set;
		}	

		public override string ToString()
		{
			return this.Name;
		}

		#region INotifyPropertyChanged
		public event PropertyChangedEventHandler PropertyChanged;
		protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
		{
			PropertyChangedEventHandler handler = this.PropertyChanged;
			if (handler != null)
			{
				handler(this, args);
			}
		}

		private void OnPropertyChanged(string propertyName)
		{
			this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
		}
		#endregion
	}
}
